<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlarmScreenNg: AS EWO API</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlarmScreenNg
   &#160;<span id="projectnumber">0.9.2</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&#160;Pages</span></a></li>
    </ul>
  </div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="page_References.html">References</a></li>  </ul>
</div>
</div><!-- top -->
<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">AS EWO API </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>The AS EWO is called <b>AS.ewo</b>, it can be found in component installation directory under </p><div class="fragment"><div class="line">bin/widgets/&lt;platform&gt;/</div>
</div><!-- fragment --><p>This sections describes API of AS EWO for WinCC OA panel, where EWO is placed: properties, methods and events.</p>
<h1><a class="anchor" id="sec_RefEwoProperties"></a>
Properties</h1>
<h2><a class="anchor" id="sec_RefEwoPropBasicDp"></a>
basicConfigDp</h2>
<p>This is the most important property of AS EWO because AS EWO is not able to operate without the name of <a class="el" href="page_RefDp.html#sec_RefDpBasicConfig">internal DP</a> containing the valid basic configuration in JSON <a class="el" href="page_RefJson.html#sec_RefJsonBasicConfig">format</a>.</p>
<p>Furthermore, all other settings for AS EWO (except for <a class="el" href="page_ConfigAdmin.html">admin settings</a>) are tightly coupled with basic configuration, and it is reflected in the structure of <a class="el" href="page_RefDp.html">DP types</a>, used for storing those other settings. For example, the filter that contains alarm property named 'alias' was saved by user when working with particular basic configuration. Later this filter, in principle, can be used also for other basic configuration, but: what if that 'other basic configuration' just does not contain the alarm property named 'alias', or if the meaning of 'alias' is dfifferent in other basic configuration? Of course, in such case previously saved filter will not wotk as expected - just because the filter was saved for another basic configuration.</p>
<h2><a class="anchor" id="sec_RefEwoPropAlarmDataRole"></a>
alarmDataRole</h2>
<p>The alarm data, read from AS EWO, are passed to CTRL script in panel (in methods or events) as CTRL data type <code>mapping</code>, where keys are the names of alarm <a class="el" href="page_AlarmProp.html">properties</a>.</p>
<p>The value of this EWO property determines what shall be the values in such <code>mapping</code>. Two values are possible: </p><ul>
<li>
<b>EditRole</b>: the values in mapping have 'native' data types. For example, the properties which hold a boolean value are returned as CTRL data type <code>bool</code> with two possible values: <code>true</code> and <code>false</code>  </li>
<li>
<b>DisplayRole</b>: the values in mapping have CTRL data type <code>string</code>, exactly as they appear to user in <a class="el" href="pageUsingAS.html#secAlarmTable">The Alarm Table</a>. In such case, the alarm property holding boolean value can be returned as strings "YES"/"NO", or "CAME"/"WENT", or in some other format, selected for displaying this particular property in table.  </li>
</ul>
<p>Note that some (but not all!) of methods of AS EWO have an argument, allowing to override this 'default' setting.</p>
<h2><a class="anchor" id="sec_RefEwoPropLog"></a>
Settings for log</h2>
<p>During operation AS EWO may produce some text messages: to inform about critical errors, warnings, or just to produce messages for debugging (for developer). These messages are sent into two places: </p><ul>
<li>
To Win CC OA log, like for many other managers  </li>
<li>
To dedicated buffer inside EWO itself, from where the list of messages can be opened (see <a class="el" href="pageUsingAS.html#secMessages">Internal messages</a>)  </li>
</ul>
<p>Every message is assosiated with one of possible levels of severity: Debug, Info, Warnign, Critical.</p>
<p>The following properties of AS EWO control the process of producing such messages, as we as content of produced messages. </p><table class="doxtable">
<tr>
<th>Property </th><th>Description  </th></tr>
<tr>
<td>logSeverity </td><td>Mininum level of severity for messages which shall appear in WinCC OA log; the default value is <b>Warning</b>  </td></tr>
<tr>
<td>userlogSeverity </td><td>Minimum level of severity for messages which shall be buffered (and observed by user) in AS EWO itself; the default value is <b>Warning</b>.  </td></tr>
<tr>
<td>logTimestamp </td><td><code>true</code> if message text shal include timestamp when message was produced by AS EWO; the default value is <code>false</code>  </td></tr>
<tr>
<td>logFunction </td><td><code>true</code> if message text shall include the name of function that produced the message; the default value is <code>false</code>  </td></tr>
</table>
<h1><a class="anchor" id="sec_RefEwoMethods"></a>
Methods</h1>
<p>The methods in this secction of document are grouped according to their purpose (intended usage). In principle, methods described can be used for other purposes if needed.</p>
<h2><a class="anchor" id="sec_RefEwoMethodsInit"></a>
Panel initialization</h2>
<p>When new <a class="el" href="page_RefEwo.html#sec_RefEwoPropBasicDp">basic configuration</a> is set to AS EWO, the EWO shall notify the panel in order to make necessary adjustments for new basic configuration. This can include, for example: loading and applying default user settings, connecting to all (or some) of systems etc.</p>
<p>The problem occurs when panel, containing AS EWO, is just created/opened: there is (short) period of time when EWO itself is ready, and may fire events for CTRL code in panel, but the panel is not ready yet to process the events from EWO. The dedicated method of EWO was introduced, that normally shall be called from the <b>Initialize</b> event of panel;</p>
<div class="fragment"><div class="line"><span class="keywordtype">string</span> ownerPanelReady();</div>
</div><!-- fragment --><p>The method returns the name of currently used <a class="el" href="page_RefEwo.html#sec_RefEwoPropBasicDp">basic configuration DP.</a></p>
<h2><a class="anchor" id="sec_RefEwoMethodsFilterParam"></a>
Source filter parameters</h2>
<p>As described in <a class="el" href="page_RefJson.html#subsubsec_RefJsonBasicConfigAlarmModel">basic configuration</a>, the configuration may contain string for FROM and WHERE clauses of query. They can be not only fixed strings, but also parametrizable strings.</p>
<p>The following two methods of EWO are used for passing to EWO list of strings which will substitute parameters in FROM and WHERE clause templates.</p>
<div class="fragment"><div class="line"><span class="keywordtype">string</span> setFromArguments(dyn_string arguments);</div>
</div><!-- fragment --><p> is used to pass parameter for FROM template of query, </p><div class="fragment"><div class="line"><span class="keywordtype">string</span> setWhereArguments(dyn_string arguments);</div>
</div><!-- fragment --><p> is used to pass parameter for WHERE template of query.</p>
<p>Both method may return non-empty string, containing error description, if calls were not successful. Note that 'successful' doesn't mean that query with passed parameters will work as expected, this doesn't even mean that query syntax is correct: 'success' here just means that parameters were passed to alarm <a class="el" href="pageUsingAS.html#secSourceTypes">source</a>.</p>
<h2><a class="anchor" id="sec_RefEwoMethodsPropsColumns"></a>
Alarm properties and table columns</h2>
<p>The methods described here are used for operations with alarm properties, defined in <a class="el" href="page_RefEwo.html#sec_RefEwoPropBasicDp">basic configuration</a>, and with set of columns shown in table. <br  />
</p>
<div class="fragment"><div class="line">dyn_mapping getAllProperties();</div>
</div><!-- fragment --><p> Get all alarm properties, defined by basic configuration. Every mapping in returned list contains the following information for alarm property: </p><ul>
<li>
<b>"id"</b>: the value is <code>string</code> with internal identifier of this alarm property, see <a class="el" href="page_AlarmProp.html">Alarm properties</a>.  </li>
<li>
<b>"alarmAttr"</b>: the value is <code>string</code> with the name of attribute of <b>_alert_hdl</b> DPE config, corresponding to this alarm property. Empty string if alarm property does not directly correspond to one of attributes of <b>_alert_hdl</b> config.  </li>
<li>
<b>"isAtime"</b>: <code>true</code> if this property is part of <code>atime</code> for alarms (reminder: <code>atime</code> includes alarm DPE, alarm time and count of alarm within 1 msec)  </li>
</ul>
<p><br  />
</p>
<div class="fragment"><div class="line">dyn_mapping getTableColumns();</div>
</div><!-- fragment --><p> Get all columns of <a class="el" href="pageUsingAS.html#secAlarmTable">Alarm Table</a>, defined in <a class="el" href="page_RefJson.html#subsubsec_RefJsonBasicConfigColumns">basic configuration</a>. Every mapping in returned list contains the following information for table column (see constants AS_TABLE_COL_xxx in CTRL library AlarmScreenNg.ctl). The method was introduced for UNICOS-style popup menu where column visibility can be modified from menu. </p><ul>
<li>
<b>"source"</b>: the value is <code>int</code> with enumerated value for the source of this column. See constants AS_TABLE_SOURCE_xxx in CTRL library AlarmScreenNg.ctl for possible values.  </li>
<li>
<b>"id"</b>: the value is <code>string</code>, containing internal name (ID) of alarm property for this table column, see <a class="el" href="page_AlarmProp.html">Alarm properties</a>.  </li>
<li>
<b>"title"</b>: the value is <code>string</code>, containing header for this table column.  </li>
<li>
<b>"width"</b>: the value is <code>int</code> - current width of this column in table [Pixels]  </li>
<li>
<b>"hideable"</b>: the value is <code>bool</code> indicating if user is allowed to hide this column of not  </li>
<li>
<b>"visible"</b>: the value is <code>bool</code> indicating if this column is currently visible in table or not  </li>
</ul>
<p><br  />
</p>
<div class="fragment"><div class="line"><span class="keywordtype">void</span> toggleTableColumnVisibility(<span class="keywordtype">int</span> column);</div>
</div><!-- fragment --><p> Toggle the visibility of column with given index, the index must correspond to one of columns returned by method getTableColumns() <br  />
</p>
<div class="fragment"><div class="line"><span class="keywordtype">void</span> showAllTableColumns();</div>
</div><!-- fragment --><p> Set all columns of table to 'visible' state.</p>
<h2><a class="anchor" id="sec_RefEwoMethodsConnect"></a>
Connection to systems</h2>
<p>The methods of this group are used to force connection/disconnection of AS EWO to WinCC OA systems.</p>
<div class="fragment"><div class="line"><span class="keywordtype">bool</span> connectSystem(<span class="keywordtype">string</span> systemName);</div>
</div><!-- fragment --><p> Connect to system with given name; returns <code>true</code> if connection was successful. If current <a class="el" href="pageUsingAS.html#secSourceTypes">source mode</a> for AS EWO is not <b>Live</b>, then AS EWO first switches to Live mode, and only after tries to connect to given system <br  />
</p>
<div class="fragment"><div class="line"><span class="keywordtype">bool</span> disconnectSystem(<span class="keywordtype">string</span> systemName);</div>
</div><!-- fragment --><p> Disconnect from system with given name; returns <code>true</code> if disconnection was successful. The method only works if AS EWO's <a class="el" href="pageUsingAS.html#secSourceTypes">source mode</a> for AS EWO is <b>Live</b>. <br  />
</p>
<div class="fragment"><div class="line">dyn_string getConnectedSystems();</div>
</div><!-- fragment --><p> Get list of all systems names to which AS EWO is connected now. If current <a class="el" href="pageUsingAS.html#secSourceTypes">source mode</a> for AS EWO is not <b>Live</b>, then the method returns list of systems to which AS EWO was connected when it was in Live mode. <br  />
</p>
<div class="fragment"><div class="line"><span class="keywordtype">string</span> queryArchived(time startTime, time endTime, dyn_string &amp;systemNames);</div>
</div><!-- fragment --><p> Starts query for data from archive. If current <a class="el" href="pageUsingAS.html#secSourceTypes">source mode</a> for AS EWO is not <b>History</b>, then AS EWO first siwtches to History mode, then starts the query. Current <a class="el" href="pageUsingAS.html#secFilterEditor">filter</a> remains unchanged, i.e. the query will be performed with current filter. </p><dl class="section note"><dt>Note</dt><dd>AS EWO will not be able to switch to <b>History</b> mode if <a class="el" href="page_ConfigAdmin.html#sec_AdminOracleAccess">credentials</a> for DB connection were not supplied.</dd></dl>
<h2><a class="anchor" id="sec_RefEwoMethodsDetails"></a>
Alarm details</h2>
<p>The methods of this group are used to read details of alarms shown in Alarm Table. Note that 'details' includes not only alarm properties, visible in table columns, but rather <b>all</b> alarm properties known inside AS EWO. The data for one alarm is <code>mapping</code> with keys = names of <a class="el" href="page_AlarmProp.html">alarm properties</a>, and values = value of that alarm property.</p>
<div class="fragment"><div class="line">dyn_mapping getAllRowsData(<span class="keywordtype">string</span> format = <span class="stringliteral">&quot;&quot;</span>);</div>
</div><!-- fragment --><p> Get details of all alarms in table. The argument <code>format</code> allows to override default setting for <a class="el" href="page_RefEwo.html#sec_RefEwoPropAlarmDataRole">alarmDataRole</a> EWO property. Two values are allowed for this argument: </p><ul>
<li>
<b>"edit"</b>: the values of alarm properties are returned as 'native' data types  </li>
<li>
<b>"display"</b>: the values of alarm properties are returned as <code>string</code> shown in table  </li>
</ul>
<p><br  />
</p>
<div class="fragment"><div class="line">dyn_mapping getSelectedRowsData(<span class="keywordtype">string</span> format = <span class="stringliteral">&quot;&quot;</span>);</div>
</div><!-- fragment --><p> Get details of all alarms in selected row(s) in table. The <code>format</code> argument is the same as for <code>getAllRowsData()</code> method above.</p>
<p>If alarms are displayed as hierarcical tree, then selecting any group node in the tree is interpreted as selecting all alarms = descendants of this group node. <br  />
</p>
<div class="fragment"><div class="line">dyn_mapping getVisibleRowsData(<span class="keywordtype">string</span> format = <span class="stringliteral">&quot;&quot;</span>);</div>
</div><!-- fragment --><p> Get details of all alarms in currently visible rows in table. The <code>format</code> argument is the same as for <code>getAllRowsData()</code> method above. <br  />
</p>
<div class="fragment"><div class="line">dyn_mapping getForAcknowledgementAll();</div>
</div><!-- fragment --><p> Get details of all unacknowledged alarms in table. Note that alarms for acknowledgement are always returned using "edit" data role, independently of the value of <a class="el" href="page_RefEwo.html#sec_RefEwoPropAlarmDataRole">alarmDataRole</a> EWO property.</p>
<div class="fragment"><div class="line">dyn_mapping getForAcknowledgementSelected();</div>
</div><!-- fragment --><p> Get details of all unacknowledged alarms, found in selected rows in table in table. Note that alarms for acknowledgement are always returned using "edit" data role, independently of the value of <a class="el" href="page_RefEwo.html#sec_RefEwoPropAlarmDataRole">alarmDataRole</a> EWO property.</p>
<p>The interpretaion of 'selected' for hierarchical tree is different from <code>getSelectedRowsData()</code> method: here only explicitly selected rows with alarms are considered, the selection of group nodes is not propagated down in tree hierarchy. <br  />
</p>
<div class="fragment"><div class="line">dyn_mapping getForAcknowledgementAllGone();</div>
</div><!-- fragment --><p> Get details of all unacknowledged alarms with direction WENT in table. Note that alarms for acknowledgement are always returned using "edit" data role, independently of the value of <a class="el" href="page_RefEwo.html#sec_RefEwoPropAlarmDataRole">alarmDataRole</a> EWO property. <br  />
</p>
<p><a class="anchor" id="anchor_RefEwoMethodRowAsString"></a></p><div class="fragment"><div class="line"><span class="keywordtype">string</span> getTableRowAsString(dyn_int row);</div>
</div><!-- fragment --><p> Very specific method, used for functionality like 'copy to clipboard' of popup menu. The method returns string with space-separated values in columns of given table row.<br  />
 The argument <code>row</code> really describes the single row in table, but why <code>dyn_int</code>? In case of flat alarm table the <code>row</code> argument shall contain just one item: the index of required row in table (zero-based). However, if alarms are displayed in hierarchical tree, then <code>dyn_int</code> shall contain the list of numbers, describing the 'route' from root of tree to required row with alarm data. This is illustrated on the following picture (tree with 2 levels of grouping):</p>
<div class="image">
<img src="complexRowIndex.png" alt=""/>
<div class="caption">
Row index for tree</div></div>
 <p>In this example <code>dyn_int</code> shall contain 3 values {2, 1, 3} in order to address highlighted row with alarm data. </p><ul>
<li>
<b>2</b> is index of group on top level </li>
<li>
<b>1</b> is index of next level group inside selected group </li>
<li>
<b>3</b> is index of alarm within the lowest level group </li>
</ul>
<p>I.e. in case of tree view, the <code>row</code> argument shall contain number of values equal to number of grouping levels plus one.</p>
<h2><a class="anchor" id="sec_RefEwoMethodsAccessControl"></a>
Access control</h2>
<p>The AS EWO itself doesn't make any assumptions on how exactly access control is configured and operated, Instead, AS EWO just provides methods, allowing to modify appearance of different elements (widgets) in EWO according to access rights of given user. The approach is simple, see <a class="el" href="page_RefActions.html">Action names</a>.</p>
<div class="fragment"><div class="line"><span class="keywordtype">string</span> setActionEnabled(<span class="keyword">const</span> <span class="keywordtype">string</span> &amp;action, <span class="keywordtype">int</span> state);</div>
</div><!-- fragment --><p> Set the state of widget inside EWO according to the ability of current user to execute given named action. The <code>state</code> shall conatin one of supported value (see constant ALARM_SCREEN_ACCESS_ACTION_xxx in CTRL library AsNgAccessControl.ctl): </p><ul>
<li>
<b>0</b>: action is allowed for user, corresponding widget in EWO shall appear in 'norma; state  </li>
<li>
<b>1</b>: action is disabled for user, corresponding widget in EWO shall appear in 'disabled' state (grayed out)  </li>
<li>
<b>2</b>: action is disabled for user, corresponding widget in EWO shall be hidden  </li>
</ul>
<p><br  />
</p>
<div class="fragment"><div class="line">dyn_string getAllActions();</div>
</div><!-- fragment --><p> Get the names of all actions, known to AS EWO. This method, together with previous one, can be used in processing the changes in access rights of current user, using the following algorithm: </p><ul>
<li>
get list of all action names, known to EWO </li>
<li>
check the access rights of current user for every action </li>
<li>
finally apply the result of check to EWO using the method <code>setActionEnabled()</code> </li>
</ul>
<h2><a class="anchor" id="sec_refEwoMethodsCustom"></a>
Custom buttons</h2>
<div class="fragment"><div class="line"><span class="keywordtype">string</span> addCustomButton(<span class="keyword">const</span> <span class="keywordtype">string</span> &amp;actionName, <span class="keyword">const</span> <span class="keywordtype">string</span> &amp;label, <span class="keyword">const</span> <span class="keywordtype">string</span> &amp;iconFile, <span class="keyword">const</span> <span class="keywordtype">string</span> &amp;tooltipText)</div>
</div><!-- fragment --><p> Add the custom button to toolbar in the <a class="el" href="pageUsingAS.html#ewoOverviewPicture">footer area</a> of AS EWO. The EWO itself doesn't know what to do with added buttons, EWO just fires corresponding <a class="el" href="page_RefEwo.html#anchor_EventCustomAction">event</a>, which shall be processed by CTRL code in panel.</p>
<p>Arguments: </p><ul>
<li>
<b>actionName</b>: the name of action linked to new button. This name is used for <a class="el" href="page_ConfigAdmin.html#sec_AccessControl">access control</a>, i.e. the CTRL code in panel can enable/disable/hide new button, based on access rights of current user, or on other conditions. This name is also passed to CTRL code in argument of corresponding <a class="el" href="page_RefEwo.html#anchor_EventCustomAction">event</a> of EWO when new button is activated by user. The argument must be non-empty string.  </li>
<li>
<b>label</b>: the label string for new button. Argument can be empty string, in such case <b>iconFile</b> argument must be non-empty.  </li>
<li>
<b>iconFile</b>: the name of file with image to be used as icon for new button. This must be the name relative to PICTURES_REL_PATH. The algorithm used by AS EWO to find the file with picture is similar to the algorithm used by <code>getPath()</code> function of CTRL, see WinCC OA online help. This argument can be empty, in such case <b>label</b> argument must be non-empty.  </li>
<li>
<b>tooltipText</b>: the tooltip text for new button.  </li>
</ul>
<p>In case of success method returns empty string; in case of error the string with error description is returned.</p>
<dl class="section note"><dt>Note</dt><dd>AS EWO doesn't check if <b>actionName</b> is unique.</dd></dl>
<h2><a class="anchor" id="sec_refEwoMethodsSpecificOptions"></a>
Specific options</h2>
<div class="fragment"><div class="line">mapping getSpecificOption(<span class="keyword">const</span> <span class="keywordtype">string</span> &amp;optionId);</div>
</div><!-- fragment --><p>The method is used to read the value of <a class="el" href="page_RefJson.html#subsect_RefJsonBasicConfigSpecificOptions">specific option</a>, given in basic configuration. The parameter is the name (ID) of specific option as it is specified in basic configuration.</p>
<h2><a class="anchor" id="sec_RefEwoMethodsOther"></a>
Other</h2>
<div class="fragment"><div class="line"><span class="keywordtype">string</span> getFilter(<span class="keywordtype">bool</span> compact);</div>
</div><!-- fragment --><p> Get the current <a class="el" href="pageUsingAS.html#subSecStructuredFilter">structured filter</a> of EWO as a string in JSON format, suitable for saving current filter to DP. The <code>compact</code> argument allows to choose between compact and pretty formatted JSON string. See <a class="el" href="page_RefJson.html#subsec_RefJsonFilter">filter</a> JSON syntax. <br  />
</p>
<div class="fragment"><div class="line"><span class="keywordtype">string</span> applyFilter(<span class="keyword">const</span> <span class="keywordtype">string</span> &amp;jsonString);</div>
</div><!-- fragment --><p> Apply previously saved filter to AS EWO. Normally the value of <code>jsonString</code> argument is read from DP where filter was saved before; the value shall contain the definition of structured filter in <a class="el" href="page_RefJson.html#subsec_RefJsonFilter">JSON format</a>. The method returns <code>string</code> with description of error if parsing/applying filter has failed; or empty string if processing was successful <br  />
</p>
<div class="fragment"><div class="line"><span class="keywordtype">string</span> getUserSettings(<span class="keywordtype">bool</span> compact);</div>
</div><!-- fragment --><p> Get the current user settings of EWO (see <a class="el" href="page_UserSettings.html">User Settings</a>) as a string in <a class="el" href="page_RefJson.html#subsec_RefJsonUserSettings">JSON format</a>, suitable for saving current user settings to DP. The <code>compact</code> argument allows to choose between compact and pretty formatted JSON string. <br  />
</p>
<div class="fragment"><div class="line"><span class="keywordtype">string</span> applyUserSettings(<span class="keyword">const</span> <span class="keywordtype">string</span> &amp;jsonString);</div>
</div><!-- fragment --><p> Apply previously saved user settings to AS EWO. Normally the value of <code>jsonString</code> argument is read from DP where user settings were saved before; the value shall contain the user settings in <a class="el" href="page_RefJson.html#subsec_RefJsonUserSettings">JSON format</a>. The method returns <code>string</code> with description of error if parsing/applying user settings has failed; or empty string if processing was successful <br  />
</p>
<div class="fragment"><div class="line">mapping getFilterStatistics(<span class="keyword">const</span> <span class="keywordtype">string</span> &amp;filterId);</div>
</div><!-- fragment --><p> Get the current statistics, collected by single filter in <a class="el" href="pageUsingAS.html#secFilterViews">Filter View</a> of AS EWO (see also <a class="el" href="page_FilterViewEditor.html">Filter View editor</a>). The <code>filterId</code> argument shall contain not the name of filter, but rather the name of DP where definition of this filter is stored. This must correspond to one of filters, shown in filter view area. In case of success the method returns <code>mapping</code>, containing values for all keys, listed in <a class="el" href="page_FilterViewEditor.html#anchor_FilterViewValueSpecs">the table</a>, plus two more keys: </p><table class="doxtable">
<tr>
<th>Key </th><th>Value </th></tr>
<tr>
<td>itemTextFormat </td><td>The text format used for visible text of all items in filter view (see <a class="el" href="page_FilterViewEditor.html#sec_FilterViewEditorTexts">text templates</a>)  </td></tr>
<tr>
<td>itemToolTipTextFormat </td><td>The text format used for tooltip text of all items oinfilter view (see <a class="el" href="page_FilterViewEditor.html#sec_FilterViewEditorTexts">text templates</a>)  </td></tr>
</table>
<p>In case of error, the returned <code>mapping</code> contains the only key "error", where value is a <code>string</code> with error description. <br  />
</p>
<p>The AS EWO has a button for <a class="el" href="pageUsingAS.html#secExportAlarms">exporting table content to CSV file</a>. In addition, the exporting operation can be initiated from CTRL code using the method</p>
<div class="fragment"><div class="line"><span class="keywordtype">string</span> exportToCsv(<span class="keyword">const</span> <span class="keywordtype">string</span> &amp;fileName = <span class="stringliteral">&quot;&quot;</span>, <span class="keywordtype">bool</span> allRows = <span class="keyword">false</span>, <span class="keywordtype">bool</span> headers = <span class="keyword">true</span>, <span class="keywordtype">bool</span> withGrouping = <span class="keyword">false</span>, <span class="keyword">const</span> dyn_string &amp;columns);</div>
</div><!-- fragment --><p> The method has the following arguments: </p><ul>
<li>
<b>fileName</b>: the name of file where resulting CSV shall be written, absolute path. If empty string is passed, then AS EWO will present file selection dialog to user,  </li>
<li>
<b>allRows</b>: <code>true</code> means writing all rows to output file, <code>false</code> - only selected rows.  </li>
<li>
<b>headers</b>: if <code>true</code> then column headers will also be written to output file.  </li>
<li>
<b>withGrouping</b>: this argument makes sense if alarms are shown in hierarchical tree. <code>true</code> means that content of grouping column shall also be written to output file.  </li>
<li>
<b>columns</b>: the list of column titles which shall be written to otuput file. Empty list is interpreted as 'write all visible columns of table'.  </li>
</ul>
<p><br  />
</p>
<div class="fragment"><div class="line"><span class="keywordtype">string</span> getUniqueId();</div>
</div><!-- fragment --><p> Get the string, uniquely identifying this instance of AS EWO in UI manager. The method is used in CTRL code for building name of module, working with particular EWO. The unique identifier can also be used for other purposes if needed. <br  />
</p>
<div class="fragment"><div class="line">setOracleRdbPass(<span class="keyword">const</span> <span class="keywordtype">string</span> &amp;pass);</div>
</div><!-- fragment --><p> It was mentioned in <a class="el" href="page_RefActions.html#sec_RefActionsSpecial">Actions</a> description that:</p><ul>
<li>AS EWO needs to know credentials in order to connected to ORACLE DB for retrieving archived alarms</li>
<li>the password for connection is stored in DPE as encoded string</li>
<li>AS EWO itself is not able to decode the password Taking these prerequisits into account, the sequence for preparing password for ORACLE is the following:</li>
<li>AS EWO reads the encoded password from DPE</li>
<li>AS EWO fires event with action name <a class="el" href="page_RefActions.html#sec_RefActionsSpecial">oraclePassRequest</a></li>
<li>CTRL code shall decode the password string and pass result to AS EWO using this method <br  />
</li>
</ul>
<div class="fragment"><div class="line">sysConnectDist(mapping callbackArg);</div>
</div><!-- fragment --><p> AS EWO needs to have notifications about event like connection/disconnection of individual systems in distributed system. One of mechanism, provided by WinCC OA for this purpose, is sysConnect() function (see WinCC OA help). However, the sysConnect() is not available in WinCC OA API, hence, C++ code of AS EWO can't use the sysConnect() call directly.<br  />
 One possible solution is the following:</p><ul>
<li>the panel, where AS EWO is located, shall call sysConnect() (for example, in Initialize event)</li>
<li>callback for this call shall call this method of AS EWO, passign the mapping arrived to callback</li>
</ul>
<h1><a class="anchor" id="sec_RefEwoEvents"></a>
Events</h1>
<p><a class="anchor" id="anchor_EwoEventsCtrlAction"></a></p><div class="fragment"><div class="line">ctrlActionRequested(mapping &amp;mArgs);</div>
</div><!-- fragment --><p>Probably, the most important and widely used event of this EWO. This event is fired on many occasions, including change of <a class="el" href="page_RefEwo.html#sec_RefEwoPropBasicDp">basic configuration</a>, activating different controls (widgets) inside AS EWO.</p>
<p>The general meaning of this event is: something happened inside AS EWO, that can't be processed by EWO itself, and this requires some processing by CTRL code.</p>
<p>Normally this event shall be processed by CTRL function </p><div class="fragment"><div class="line"><span class="keywordtype">void</span> AlarmScreenNgEwo_ctrlActionRequested(mapping &amp;mArgs);</div>
</div><!-- fragment --><p> which is defined in CTRL library AlarmScreenNgEwo.ctl</p>
<p>The only argument of this event contains the following keys (all keys are strings): </p><ul>
<li>
<b>"sAction"</b>: the value is a <code>string</code> identifying requested action, see <a class="el" href="page_RefActions.html">Action names</a>.  </li>
<li>
<b>"sCtrlLib"</b>: the value is a <code>string</code>, containing the name of CTRL library to be loaded for processing this event. See <a class="el" href="page_RefJson.html#sec_RefJsonBasicConfig">Basic configuration</a>.  </li>
<li>
<b>"sCtrlFunc"</b>: the value is a <code>string</code>, containing the name of CTRL function to be called for processing this event. See <a class="el" href="page_RefJson.html#sec_RefJsonBasicConfig">Basic configuration</a>.  </li>
<li>
<b>"sourceMode"</b>: the value is <code>int</code>, enumerating current <a class="el" href="pageUsingAS.html#secSourceTypes">source type</a> for AS EWO; the following values are possible: <ul>
<li>
<b>0</b>: AS EWO operates without data source, i.e. it does not display any alarms. This can happen if empty/invalid basic configuration is set for AS EWO.  </li>
<li>
<b>1</b>: AS EWO operates with <b>Live</b> alarms from WinCC OA project  </li>
<li>
<b>2</b>: AS EWO operates with <b>History</b> alarms from archive </li>
</ul>
See constants AS_NG_EWO_MODE_xxx, defined in CTRL library AlarmScreenNgEwo.ctl  </li>
</ul>
<p><br  />
</p>
<div class="fragment"><div class="line">mouseEvent(mapping &amp;mArgs);</div>
</div><!-- fragment --><p> Next important event, which is fired in response to user's mouse button events on table row with alarm data. The only argument for this event contains all keys for event <code>ctrlActionRequested()</code>, plus some more keys: </p><ul>
<li>
<b>"mSource"</b>: the value is another <code>mapping</code> with information on event source, contains the following keys of type <code>string</code>: <ul>
<li>
<b>"button"</b>: the value is <code>int</code>, indicating which mouse button caused this event  </li>
<li>
<b>"screenX"</b>: the value is <code>int</code>, X-ccordinate of mouse event that caused this event. The coordinate is in screen's coordinate system  </li>
<li>
<b>"screenY"</b>: the value is <code>int</code>, Y-ccordinate of mouse event that caused this event. The coordinate is in screen's coordinate system  </li>
<li>
<b>"row"</b>: the value is <code>dyn_int</code>, containing the index of table row where mouse event occured. See the EWO's method <a class="el" href="page_RefEwo.html#anchor_RefEwoMethodRowAsString">getTableRowAsString()</a> for description of content of this <code>dyn_int</code>  </li>
<li>
<b>"columnSource"</b>: the value is <code>int</code>, enumerated source of information for column where mouse event occured. See constants AS_TABLE_SOURCE_xxx in CTRL library AlarmScreenNg.ctl for possible values.  </li>
<li>
<b>"columnId"</b>: the value is <code>string</code>, identifying the alarm property shown in column where mouse event occured, see <a class="el" href="page_AlarmProp.html">Alarm properties</a>  </li>
</ul>
</li>
<li>
<b>"mAlarm"</b>: the value is <code>mapping</code> with all properties of alarm in a row where mouse event occured, see <a class="el" href="page_AlarmProp.html">Alarm properties</a>  </li>
</ul>
<p><br  />
</p>
<div class="fragment"><div class="line">sourceStateChanged(mapping &amp;mArgs);</div>
</div><!-- fragment --><p>This event is fired when the state of alarm <a class="el" href="page_RefJson.html#subsec_RefJsonBasicConfigModels">source</a> in EWO has changed. Initially event was introduced for testing, but it can also be used for other purposes. The only argument of this event contains the following keys (all keys are strings): </p><ul>
<li>
<b>"sCtrlLib"</b>: the value is empty string.  </li>
<li>
<b>"sCtrlFunc"</b>: the value is empty string.  </li>
<li>
<b>"sourceMode"</b>: the value is <code>int</code>, enumerating current <a class="el" href="pageUsingAS.html#secSourceTypes">source type</a> of AS EWO; the following values are possible: <ul>
<li>
<b>0</b>: AS EWO operates without data source, i.e. it does not display any alarms. This can happen if empty/invalid basic configuration is set for AS EWO.  </li>
<li>
<b>1</b>: AS EWO operates with <b>Live</b> data from WinCC OA project  </li>
<li>
<b>2</b>: AS EWO operates with <b>History</b> data from archive </li>
</ul>
See constants AS_NG_EWO_MODE_xxx, defined in CTRL library AlarmScreenNgEwo.ctl  </li>
<li>
<b>"iState"</b>: current state of alarm source, see constants <code>AS_NG_EWO_SOURCE_xxx</code> in CTRL library AlarmScreenNgEwo.ctl  </li>
</ul>
<p><br  />
</p>
<div class="fragment"><div class="line">sourceCountsChanged(mapping &amp;mArgs);</div>
</div><!-- fragment --><p>This event is fired when the number of alarms, processed by <a class="el" href="page_RefJson.html#subsec_RefJsonBasicConfigModels">source</a> in EWO, have changed. Initially this event was introduced for testing, but it can also be used for other purposes. The only argument of this event contains the following keys (all keys are strings): </p><ul>
<li>
<b>"sCtrlLib"</b>: the value is empty string.  </li>
<li>
<b>"sCtrlFunc"</b>: the value is empty string.  </li>
<li>
<b>"sourceMode"</b>: the value is <code>int</code>, enumerating current <a class="el" href="pageUsingAS.html#secSourceTypes">source type</a> of AS EWO; the following values are possible: <ul>
<li>
<b>0</b>: AS EWO operates without data source, i.e. it does not display any alarms. This can happen if empty/invalid basic configuration is set for AS EWO.  </li>
<li>
<b>1</b>: AS EWO operates with <b>Live</b> data from WinCC OA project  </li>
<li>
<b>2</b>: AS EWO operates with <b>History</b> data from archive </li>
</ul>
See constants AS_NG_EWO_MODE_xxx, defined in CTRL library AlarmScreenNgEwo.ctl  </li>
<li>
<b>"iArrived"</b>: number of alarms arrived to source from outside (from online systems, from archive...  </li>
<li>
<b>"iProcessed"</b>: number of alarms passed by source further to <a class="el" href="page_RefJson.html#subsec_RefJsonBasicConfigModels">alarms model</a>  </li>
</ul>
<p><br  />
</p>
<p><a class="anchor" id="anchor_EventCustomAction"></a></p><div class="fragment"><div class="line">customAction(mapping &amp;mArgs);</div>
</div><!-- fragment --><p>This event is fired when one of <a class="el" href="page_RefEwo.html#sec_refEwoMethodsCustom">custom buttons</a> was clicked by user. The only argument of this event contains the following keys (all keys are strings): </p><ul>
<li>
<b>"sAction"</b>: the value is a <code>string</code> identifying requested action. The value corresponds to <code>actionName</code> argument for <a class="el" href="page_RefEwo.html#sec_refEwoMethodsCustom">addCustomButton()</a> method which added this button.  </li>
<li>
<b>"sCtrlLib"</b>: the value is a <code>string</code>, containing the name of CTRL library to be loaded for processing this event. See <a class="el" href="page_RefJson.html#sec_RefJsonBasicConfig">Basic configuration</a>.  </li>
<li>
<b>"sCtrlFunc"</b>: the value is a <code>string</code>, containing the name of CTRL function to be called for processing this event. See <a class="el" href="page_RefJson.html#sec_RefJsonBasicConfig">Basic configuration</a>.  </li>
<li>
<b>"sourceMode"</b>: the value is <code>int</code>, enumerating current <a class="el" href="pageUsingAS.html#secSourceTypes">source type</a> of AS EWO; the following values are possible: <ul>
<li>
<b>0</b>: AS EWO operates without data source, i.e. it does not display any alarms. This can happen if empty/invalid basic configuration is set for AS EWO.  </li>
<li>
<b>1</b>: AS EWO operates with <b>Live</b> data from WinCC OA project  </li>
<li>
<b>2</b>: AS EWO operates with <b>History</b> data from archive </li>
</ul>
See constants AS_NG_EWO_MODE_xxx, defined in CTRL library AlarmScreenNgEwo.ctl  </li>
<li>
<b>"screenX"</b>: the value is <code>int</code>, X-ccordinate of <b>center</b> of custom button that was activated. The coordinate is in screen's coordinate system.  </li>
<li>
<b>"screenY"</b>: the value is <code>int</code>, Y-ccordinate of <b>center</b> of custom button that was activated. The coordinate is in screen's coordinate system.  </li>
</ul>
<p>The values <b>screenX</b> and <b>screenY</b> are added to arguments in order to allow for CTRL code to display menu when processing this event, see <code>popupMenuXY()</code> in WinCC OA online help. </p>
</div></div><!-- contents -->
</div><!-- PageDoc -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
